local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables
local equipped = x.Equipped
local dot = x.Dot
local variable = x.Variables
local azerite = x.Azerite
local talent = x.Talent
local buff = x.Buff

-- SpellFlash API:
-- http://wow.curseforge.com/addons/spellflash/pages/api/

-- Updated variable references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-local-x-spell-flash-addon-updated-variables
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff


-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
a.SetSpamFunction(function() a.RunSpamTable()

	s.UpdateTarget()

	x.InCombat = s.InCombat()
	x.Spec = s.TalentMastery()
	x.MaxHealth = s.MaxHealth("player")
	x.Health = s.Health("player")
	x.ActiveEnemies = s.SpellTargets()
	x.Haste = 100 / (100 + UnitSpellHaste("player"))
	x.MaxGCD = math.max(1, 1.5 * x.Haste)
	x.UseLongCD = s.UseLongCD()

	if x.Spec == 1 then
		-- Balance

		x.AstralPower = s.MyModifiedPower(Enum.PowerType.AstralPower)
		x.AstralPowerDeficit = UnitPowerMax("player", Enum.PowerType.AstralPower) - x.AstralPower

		-- Azerite variables
		variable.az_ss = azerite.streaking_stars.rank
		variable.az_ap = azerite.arcanic_pulsar.rank
		-- Starfall v Starsurge target cutoff
		variable.sf_targets = 4
		if talent.twin_moons.enabled and (azerite.arcanic_pulsar.enabled or talent.starlord.enabled) then
			variable.sf_targets = variable.sf_targets + 1
		end
		if not azerite.arcanic_pulsar.enabled and not talent.starlord.enabled and talent.stellar_drift.enabled then
			variable.sf_targets = variable.sf_targets - 1
		end

		-- Executed before combat begins. Accepts non-harmful actions only.
		if not x.InCombat and x.Enemy and not s.Casting(nil, "player") then
			a.Flash(
				"flask_balance"
				,"food"
				,"augmentation"
				,"moonkin_form"
				,"potion_balance"
				,"solar_wrath"
			)
			return
		end

		a.Flash("solar_beam")

		-- Executed every time the actor is available.
		if talent.incarnation.enabled then
			s.UpdateBuff(102560, "ca_inc")
			s.UpdateCooldown(102560, "ca_inc")
		else
			s.UpdateBuff(194223, "ca_inc")
			s.UpdateCooldown(194223, "ca_inc")
		end
		a.Flash(
			"potion,if=buff.ca_inc.remains>6&active_enemies=1"
			,"potion,name=battle_potion_of_intellect,if=buff.ca_inc.remains>6"
			,"berserking,if=buff.ca_inc.up"
--			,"use_item,name=balefire_branch,if=equipped.159630&cooldown.ca_inc.remains>30"
--			,"use_item,name=dread_gladiators_badge,if=equipped.161902&cooldown.ca_inc.remains>30"
--			,"use_item,name=azurethos_singed_plumage,if=equipped.161377&cooldown.ca_inc.remains>30"
--			,"use_items,if=cooldown.ca_inc.remains>30"
			,"warrior_of_elune"
		)

		s.UpdateBuff(279648, "Lively Spirit")
		s.UpdateBuff(279709, "Starlord")
		-- CDs
		a.Flash(
--			,"innervate,if=azerite.lively_spirit.enabled&(cooldown.incarnation.remains<2|cooldown.celestial_alignment.remains<12)"
			"incarnation,if=astral_power>=40"
			,"celestial_alignment,if=astral_power>=40&(!azerite.lively_spirit.enabled|buff.lively_spirit.up)&(buff.starlord.stack>=2|!talent.starlord.enabled|!variable.az_ss)"
			,"fury_of_elune,if=(buff.ca_inc.up|cooldown.ca_inc.remains>30)&solar_wrath.ap_check"
			,"force_of_nature,if=(buff.ca_inc.up|cooldown.ca_inc.remains>30)&ap_check"
		)

		s.UpdateBuff(287790, "Arcanic Pulsar")
		s.UpdateBuff(164545, "Solar Empowerment")
		s.UpdateBuff(164547, "Lunar Empowerment")
		s.UpdateBuff(202425, "Warrior of Elune")
		s.UpdateDoT(164812, "Moonfire")
		s.UpdateDoT(164815, "Sunfire")
		s.UpdateDoT(202347, "Stellar Flare")
		s.UpdateCastTime(274281, "New Moon")
		s.UpdateCastTime(274282, "Half Moon")
		s.UpdateCastTime(274283, "Full Moon")
		s.UpdateCastTime(78674, "Starsurge")
		a.Flash(
			-- Spenders
--			"cancel_buff,name=starlord,if=buff.starlord.remains<8&!solar_wrath.ap_check"
			"starfall,if=(buff.starlord.stack<3|buff.starlord.remains>=8)&spell_targets>=variable.sf_targets&(target.time_to_die+1)*spell_targets>cost/2.5"
			,"starsurge,if=(talent.starlord.enabled&(buff.starlord.stack<3|buff.starlord.remains>=8&buff.arcanic_pulsar.stack<8)|!talent.starlord.enabled&(buff.arcanic_pulsar.stack<8|buff.ca_inc.up))&spell_targets.starfall<variable.sf_targets&buff.lunar_empowerment.stack+buff.solar_empowerment.stack<4&buff.solar_empowerment.stack<3&buff.lunar_empowerment.stack<3&(!variable.az_ss|!buff.ca_inc.up|!prev.starsurge)|target.time_to_die<=execute_time*astral_power/40|!solar_wrath.ap_check"
			-- DoTs
			,"sunfire,target_if=refreshable,if=ap_check&floor(target.time_to_die/tick_time)*spell_targets>=4+spell_targets&(spell_targets>1+talent.twin_moons.enabled|dot.moonfire.ticking)&(!variable.az_ss|!buff.ca_inc.up|!prev.sunfire)"
			,"moonfire,target_if=refreshable,if=ap_check&floor(target.time_to_die/tick_time)*spell_targets>=6&(!variable.az_ss|!buff.ca_inc.up|!prev.moonfire)"
			,"stellar_flare,target_if=refreshable,if=ap_check&floor(target.time_to_die/tick_time)>=5&(!variable.az_ss|!buff.ca_inc.up|!prev.stellar_flare)"
			-- Generators
			,"new_moon,if=ap_check"
			,"half_moon,if=ap_check"
			,"full_moon,if=ap_check"
			,"lunar_strike,if=buff.solar_empowerment.stack<3&(ap_check|buff.lunar_empowerment.stack=3)&((buff.warrior_of_elune.up|buff.lunar_empowerment.up|spell_targets>=2&!buff.solar_empowerment.up)&(!variable.az_ss|!buff.ca_inc.up|(!prev.lunar_strike&!talent.incarnation.enabled|prev.solar_wrath))|variable.az_ss&buff.ca_inc.up&prev.solar_wrath)"
			,"solar_wrath,if=variable.az_ss<3|!buff.ca_inc.up|!prev.solar_wrath"
			-- Fallthru for movement
			,"sunfire"
		)


	elseif x.Spec == 2 then
		-- Feral

		x.CP = s.Power("player", Enum.PowerType.ComboPoints)
		x.Energy = s.Power("player", Enum.PowerType.Energy)
		x.EnergyRegen = s.PowerRegeneration()
		x.MaxEnergy = UnitPowerMax("player", Enum.PowerType.Energy)

		s.UpdateBuff(5215, "Prowl")
		s.UpdateBuff(145152, "Bloodtalons")

		a.Flash("wild_charge_cat")

		-- Executed before combat begins. Accepts non-harmful actions only.
		if not x.InCombat and x.Enemy then
			a.Flash(
				"flask_feral"
				,"food"
				,"augmentation"
				,"regrowth,if=talent.bloodtalons.enabled"
				,"cat_form"
				,"prowl"
				,"potion_feral"
				,"berserk"
			)
			-- It is worth it for almost everyone to maintain thrash
			variable.use_thrash = s.If(azerite.wild_fleshrending.enabled, 2, 0)
			-- Opener TF is delayed if we need to hardcast regrowth later on in the rotation
			-- This happens when Sabertooth, Bloodtalons but not LI is talented
			variable.delayed_tf_opener = s.If(talent.sabertooth.enabled and talent.bloodtalons.enabled and not talent.lunar_inspiration.enabled, 1, 0)
			variable.opener_done = false
			if buff.prowl.down or (buff.bloodtalons.down and talent.bloodtalons.enabled) then return end
		end

		a.Flash("skull_bash")

		s.UpdateDoT(1079, "Rip")
		s.UpdateDoT(155722, "Rake")
		s.UpdateDoT(106830, "Thrash")
		s.UpdateDoT(155625, "moonfire_cat")
		s.UpdateBuff(69369, "Predatory Swiftness")
		s.UpdateBuff(135700, "Clearcasting")
		s.UpdateBuff(102543, "incarnation")
		s.UpdateBuff(145152, "Bloodtalons")
		s.UpdateBuff(52610, "Savage Roar")
		s.UpdateBuff(5217, "Tiger's Fury")
		s.UpdateBuff(768, "Cat Form")
		s.UpdateBuff(285646, "Scent of Blood")
		s.UpdateCooldown(5217, "Tiger's Fury")
		s.UpdateBuff(276026, "Iron Jaws")
		s.UpdateBuff(252071, "Jungle Stalker")

		-- Executed every time the actor is available.
		--,"run_action_list,name=opener,if=variable.opener_done=0"
		if not variable.opener_done then
			-- Opener
			-- The opener generally follow the logic of the rest of the apl, but is separated out here for logical clarity
			-- Opening TF will be delayed if we need to hardcast later (which happens with sabertooth & bt but no li)
			-- Otherwise we will open with TF, you can safely cast this from stealth without breaking it.
			variable.opener_done = dot.rip.ticking
			a.Flash(
				"tigers_fury,if=variable.delayed_tf_opener=0"
				-- Always open with rake, consuming stealth and one BT charge (if talented)
				,"rake,if=!ticking|buff.prowl.up"
				-- Lets make sure we end the opener "sequence" when our first rip is ticking
--				,"variable,name=opener_done,value=dot.rip.ticking"
				-- Break out of the action list
--				,"wait,sec=0.001,if=dot.rip.ticking"
				-- If we have LI, and haven't applied it yet use moonfire.
				-- OR, if we only have one BT charge active spam moonfire until we can apply rip with it
				,"moonfire_cat,if=!ticking|buff.bloodtalons.stack=1&combo_points<5"
				-- Given current tuning it is always worth maintaining thrash, so lets apply it here.
				,"thrash,if=!ticking&combo_points<5"
				-- And if none of the above apply, we simply shred until 5
				,"swipe_cat,if=combo_points<5&spell_targets.swipe_cat>1"
				,"shred,if=combo_points<5"
				-- Regrowth, when we have 5 combo points and bloodtalons and either:
				-- We have Sabertooth and no active bloodtalons stack (via MF spam) even if it requires a hard cast
				-- We have a predatory swiftness proc available (via SR fishing)
				,"regrowth,if=combo_points=5&talent.bloodtalons.enabled&(talent.sabertooth.enabled&buff.bloodtalons.down|buff.predatory_swiftness.up)"
				-- If we ended up hardcasting Regrowth, use TF to re-enter cat form
				,"tigers_fury"
				-- And once we get here at 5 combo_points, just rip and we are up and running
				,"primal_wrath,target_if=spell_targets.primal_wrath>=2&combo_points=5"
				,"rip,if=combo_points=5"
			)
			return
		end

		if a.Flash(
			-- Single Target
			"cat_form,if=!buff.cat_form.up"
			,"rake,if=buff.prowl.up|buff.shadowmeld.up"
		) then return end

		a.Flash(
			-- Cooldowns
			"dash,if=!buff.cat_form.up"
			,"prowl,if=buff.incarnation.remains<0.5&buff.jungle_stalker.up"
			,"berserk,if=energy>=30&(cooldown.tigers_fury.remains>5|buff.tigers_fury.up)"
			,"tigers_fury,if=energy.deficit>=60"
			,"berserking"
			,"feral_frenzy,if=combo_points=0"
			,"incarnation,if=energy>=30&(cooldown.tigers_fury.remains>15|buff.tigers_fury.up)"
			,"potion,name=battle_potion_of_agility,if=target.time_to_die<65|(time_to_die<180&(buff.berserk.up|buff.incarnation.up))"
--			,"shadowmeld,if=combo_points<5&energy>=action.rake.cost&dot.rake.pmultiplier<2.1&buff.tigers_fury.up&(buff.bloodtalons.up|!talent.bloodtalons.enabled)&(!talent.incarnation.enabled|cooldown.incarnation.remains>18)&!buff.incarnation.up"
--			,"use_items"
		)

		if a.Flash(
--			"feral_frenzy,if=combo_points=0"
			"ferocious_bite,target_if=dot.rip.ticking&dot.rip.remains<3&target.time_to_die>10&(target.health.pct<25|talent.sabertooth.enabled)"
			,"regrowth,if=combo_points=5&buff.predatory_swiftness.up&talent.bloodtalons.enabled&buff.bloodtalons.down&(!buff.incarnation.up|dot.rip.remains<8)"
		) then
			return
		end

		--,"run_action_list,name=st_finishers,if=combo_points>4"
		if x.CP > 4 then
			a.Flash(
				-- ST Finisher
--				"pool_resource,for_next=1"
				"savage_roar,if=buff.savage_roar.down"
--				,"pool_resource,for_next=1"
				,"primal_wrath,target_if=spell_targets.primal_wrath>1&dot.rip.remains<4"
--				,"pool_resource,for_next=1"
				,"primal_wrath,target_if=spell_targets.primal_wrath>=2"
--				,"pool_resource,for_next=1"
				,"rip,target_if=!ticking|(remains<=duration*0.3)&(target.health.pct>25&!talent.sabertooth.enabled)|(remains<=duration*0.8&persistent_multiplier>dot.rip.pmultiplier)&target.time_to_die>8"
--				,"pool_resource,for_next=1"
				,"savage_roar,if=buff.savage_roar.remains<12"
--				,"pool_resource,for_next=1"
				,"maim,if=buff.iron_jaws.up"
				,"regrowth,if=buff.predatory_swiftness.up&(energy.max-energy)%energy.regen>1"
				,"ferocious_bite,max_energy=1"
			)
			return
		end

		--,"run_action_list,name=st_generators"
		a.Flash(
			-- ST Generators
			"regrowth,if=talent.bloodtalons.enabled&buff.predatory_swiftness.up&buff.bloodtalons.down&combo_points=4&dot.rake.remains<4"
			,"regrowth,if=talent.bloodtalons.enabled&buff.bloodtalons.down&buff.predatory_swiftness.up&talent.lunar_inspiration.enabled&dot.rake.remains<1"
			,"brutal_slash,if=spell_targets.brutal_slash>desired_targets"
--			,"pool_resource,for_next=1"
			,"thrash_cat,if=(refreshable)&(spell_targets.thrash_cat>2)"
--			,"pool_resource,for_next=1"
			,"thrash_cat,if=(talent.scent_of_blood.enabled&buff.scent_of_blood.down)&spell_targets.thrash_cat>3"
--			,"pool_resource,for_next=1"
			,"swipe_cat,if=buff.scent_of_blood.up"
--			,"pool_resource,for_next=1"
			,"rake,target_if=!ticking|(!talent.bloodtalons.enabled&remains<duration*0.3)&target.time_to_die>4"
--			,"pool_resource,for_next=1"
			,"rake,target_if=talent.bloodtalons.enabled&buff.bloodtalons.up&((remains<=7)&persistent_multiplier>dot.rake.pmultiplier*0.85)&target.time_to_die>4"
			-- With LI & BT, we can use moonfire to save BT charges, allowing us to better refresh rake
			,"moonfire_cat,if=buff.bloodtalons.up&buff.predatory_swiftness.down&combo_points<5"
			,"brutal_slash,if=(buff.tigers_fury.up&(raid_event.adds.in>(1+max_charges-charges_fractional)*recharge_time))"
			,"moonfire_cat,target_if=refreshable"
--			,"pool_resource,for_next=1"
			,"thrash_cat,if=refreshable&((variable.use_thrash=2&(!buff.incarnation.up|azerite.wild_fleshrending.enabled))|spell_targets.thrash_cat>1)"
			,"thrash_cat,if=refreshable&variable.use_thrash=1&buff.clearcasting.react&(!buff.incarnation.up|azerite.wild_fleshrending.enabled)"
--			,"pool_resource,for_next=1"
			,"swipe_cat,if=spell_targets.swipe_cat>1"
			,"shred,if=dot.rake.remains>(action.shred.cost+action.rake.cost-energy)%energy.regen|buff.clearcasting.react"
		)

	elseif x.Spec == 3 then
		-- Guardian

		x.Rage = UnitPower("player", Enum.PowerType.Rage)
		a.Flash("wild_charge_bear") -- if we are not in range, use these
		a.Flash("skull_bash") -- interrupt spellcasting
		a.Flash("growl") -- taunt if tanking and not keeping aggro

		-- Executed before combat begins. Accepts non-harmful actions only.
		if not x.InCombat and x.Enemy then
			a.Flash(
				"flask_guardian"
				,"food"
				,"augmentation"
				,"bear_form"
				,"potion_guardian"
			)
		end

		s.UpdateBuff(5487, "Bear Form")
		a.Flash(
			"auto_attack"
			,"potion_guardian"
			,"berserking"
			,"barkskin,if=buff.bear_form.up"
			,"lunar_beam,if=buff.bear_form.up"
			,"bristling_fur,if=buff.bear_form.up"
--			,"use_items"
		)

		s.UpdateDoT(164812, "Moonfire")
		s.UpdateDoT(192090, "Thrash Bear")
		s.UpdateBuff(102558, "Incarnation")
		s.UpdateBuff(192081, "Ironfur")
		s.UpdateBuff(213708, "Galactic Guardian")
		a.Flash(
			"ironfur,if=buff.ironfur.down&rage>60"
			,"frenzied_regeneration,if=incoming_damage_5s%health.max>=0.5|health<=health.max*0.4"
			,"maul,if=rage.deficit<10&active_enemies<4"
			,"ironfur,if=cost=0|(rage>cost&azerite.layered_mane.enabled&active_enemies>2)"
			,"pulverize,target_if=dot.thrash_bear.stack=dot.thrash_bear.max_stacks"
			,"moonfire,target_if=dot.moonfire.refreshable&active_enemies<2"
			,"incarnation"
			,"thrash,if=(buff.incarnation.down&active_enemies>1)|(buff.incarnation.up&active_enemies>4)"
			,"swipe,if=buff.incarnation.down&active_enemies>4"
			,"mangle,if=dot.thrash_bear.ticking"
			,"moonfire,target_if=buff.galactic_guardian.up&active_enemies<2"
			,"thrash"
			,"maul"
			,"swipe"
		)

	end
end)
